From 3428bd3d43199631f00cea23c1d0c1637b1bae75 Mon Sep 17 00:00:00 2001
From: Stefan Knoblich <s.knoblich@axsentis.de>
Date: Mon, 1 Nov 2010 00:47:43 +0100
Subject: [PATCH 1/2] ftmod_isdn: FreeTDM port, first steps
 - Requires non-public development version of libisdn(!)
 - Based on older patches from http://oss.axsentis.de/gitweb/?p=ftmod_isdn.git;a=summary
 - Rework of ftmod_isdn related buildsystem parts (Makefile.am, configure.in and libpcap.m4)

---
 libs/freetdm/Makefile.am                           |   35 +-
 libs/freetdm/build/libpcap.m4                      |   14 +-
 libs/freetdm/configure.ac                          |   56 +
 libs/freetdm/src/ftmod/ftmod_isdn/ftdm_isdn.h      |   96 --
 libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c     | 1655 ++++++++++++--------
 libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.h     |  105 ++
 .../src/ftmod/ftmod_isdn/ozmod_isdn.2005.vcproj    |  316 ----
 7 files changed, 1203 insertions(+), 1074 deletions(-)
 delete mode 100644 libs/freetdm/src/ftmod/ftmod_isdn/ftdm_isdn.h
 create mode 100644 libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.h
 delete mode 100644 libs/freetdm/src/ftmod/ftmod_isdn/ozmod_isdn.2005.vcproj

diff --git a/libs/freetdm/Makefile.am b/libs/freetdm/Makefile.am
index d14013a..33e287f 100644
--- a/libs/freetdm/Makefile.am
+++ b/libs/freetdm/Makefile.am
@@ -161,7 +161,7 @@ testanalog_CFLAGS  = $(AM_CFLAGS) $(MY_CFLAGS)
 #
 # ftmod modules
 #
-mod_LTLIBRARIES = ftmod_zt.la ftmod_skel.la ftmod_analog.la ftmod_analog_em.la #ftmod_isdn.la
+mod_LTLIBRARIES = ftmod_zt.la ftmod_skel.la ftmod_analog.la ftmod_analog_em.la
 
 
 if HAVE_SCTP 
@@ -209,32 +209,13 @@ ftmod_wanpipe_la_LDFLAGS = -module -avoid-version -lsangoma
 ftmod_wanpipe_la_LIBADD  = $(MYLIB)
 endif
 
-#ftmod_isdn_la_SOURCES = \
-#$(SRC)/isdn/EuroISDNStateNT.c \
-#$(SRC)/isdn/EuroISDNStateTE.c \
-#$(SRC)/isdn/mfifo.c \
-#$(SRC)/isdn/Q921.c \
-#$(SRC)/isdn/Q931api.c \
-#$(SRC)/isdn/Q931.c \
-#$(SRC)/isdn/Q931ie.c \
-#$(SRC)/isdn/Q931mes.c \
-#$(SRC)/isdn/Q931StateNT.c \
-#$(SRC)/isdn/Q931StateTE.c \
-#$(SRC)/isdn/nationalmes.c \
-#$(SRC)/isdn/nationalStateNT.c \
-#$(SRC)/isdn/nationalStateTE.c \
-#$(SRC)/isdn/DMSmes.c \
-#$(SRC)/isdn/DMSStateNT.c \
-#$(SRC)/isdn/DMSStateTE.c \
-#$(SRC)/isdn/5ESSmes.c \
-#$(SRC)/isdn/5ESSStateNT.c \
-#$(SRC)/isdn/5ESSStateTE.c \
-#$(SRC)/isdn/Q932mes.c \
-#$(SRC)/ftmod/ftmod_isdn/ftmod_isdn.c
-
-#ftmod_isdn_la_CFLAGS  = $(AM_CFLAGS) $(MY_CFLAGS) -D_GNU_SOURCE
-#ftmod_isdn_la_LDFLAGS = $(PCAP_LIB_FLAGS) -module -avoid-version
-#ftmod_isdn_la_LIBADD  = $(MYLIB)
+if HAVE_LIBISDN
+mod_LTLIBRARIES += ftmod_isdn.la
+ftmod_isdn_la_SOURCES  = $(SRC)/ftmod/ftmod_isdn/ftmod_isdn.c
+ftmod_isdn_la_CFLAGS   = $(AM_CFLAGS) $(MY_CFLAGS) -D_GNU_SOURCE $(LIBISDN_CPPFLAGS) $(PCAP_CPPFLAGS)
+ftmod_isdn_la_LDFLAGS  = -shared -module -avoid-version $(LIBISDN_LDFLAGS) $(PCAP_LDFLAGS)
+ftmod_isdn_la_LIBADD   = $(MYLIB) $(LIBISDN_LIBS) $(PCAP_LIBS)
+endif
 
 ftmod_analog_la_SOURCES = $(SRC)/ftmod/ftmod_analog/ftmod_analog.c
 ftmod_analog_la_CFLAGS  = $(AM_CFLAGS) $(MY_CFLAGS)
diff --git a/libs/freetdm/build/libpcap.m4 b/libs/freetdm/build/libpcap.m4
index c20d345..ea7581e 100644
--- a/libs/freetdm/build/libpcap.m4
+++ b/libs/freetdm/build/libpcap.m4
@@ -2,6 +2,10 @@ dnl libpcap.m4--PCAP libraries and includes
 dnl Derrick Brashear
 dnl from KTH krb and Arla
 dnl $Id: libpcap.m4,v 1.4 2006/01/20 20:21:09 snsimon Exp $
+dnl 2010/10/31 (stkn):
+dnl 	rename: PCAP_INC_FLAGS -> PCAP_CPPFLAGS
+dnl 	rename: PCAP_LIB_FLAGS -> PCAP_LDFLAGS	(-L flags only)
+dnl 	add:    PCAP_LIBS (libs only)
 
 AC_DEFUN([PCAP_INC_WHERE1], [
 ac_cv_found_pcap_inc=no
@@ -129,12 +133,14 @@ AC_ARG_WITH(pcap-include,
 	  AC_MSG_RESULT(yes)
 	  PCAP_INC_DIR=$ac_cv_pcap_where_inc
 	  PCAP_LIB_DIR=$ac_cv_pcap_where_lib
-	  PCAP_INC_FLAGS="-I${PCAP_INC_DIR}"
-	  PCAP_LIB_FLAGS="-L${PCAP_LIB_DIR} -lpcap"
+	  PCAP_CPPFLAGS="-I${PCAP_INC_DIR}"
+	  PCAP_LDFLAGS="-L${PCAP_LIB_DIR}"
+	  PCAP_LIBS="-lpcap"
 	  AC_SUBST(PCAP_INC_DIR)
 	  AC_SUBST(PCAP_LIB_DIR)
-	  AC_SUBST(PCAP_INC_FLAGS)
-	  AC_SUBST(PCAP_LIB_FLAGS)
+	  AC_SUBST(PCAP_CPPFLAGS)
+	  AC_SUBST(PCAP_LDFLAGS)
+	  AC_SUBST(PCAP_LIBS)
 	  AC_DEFINE([HAVE_LIBPCAP],[1],[libpcap])
         else
 	  ac_cv_found_pcap=no
diff --git a/libs/freetdm/configure.ac b/libs/freetdm/configure.ac
index 18f83d8..457e525 100644
--- a/libs/freetdm/configure.ac
+++ b/libs/freetdm/configure.ac
@@ -12,6 +12,7 @@ AM_INIT_AUTOMAKE(libfreetdm,0.1)
 AC_PROG_CC
 AC_PROG_MAKE_SET
 AM_PROG_CC_C_O
+PKG_PROG_PKG_CONFIG
 
 AC_PREFIX_DEFAULT(/usr/local/freetdm)
 # AC_PREFIX_DEFAULT does not get expanded until too late so we need to do this to use prefix in this script                                                     
@@ -217,8 +218,63 @@ if test "${have_sng_ss7}" = "yes"; then
 	fi
 fi
 
+##
+# libisdn
+#
+HAVE_LIBISDN="no"
+AC_ARG_WITH([libisdn],
+	[AS_HELP_STRING([--with-libisdn], [Install ftmod_isdn (libisdn stack)])],
+	[case "${withval}" in
+	 no)	with_libisdn="no" ;;
+	 *)	with_libisdn="yes" ;;
+	 esac
+	],
+	[with_libisdn="no"]
+)
+if test "${with_libisdn}" != "no"
+then
+	AC_MSG_RESULT([${as_nl}<<>> ftmod_isdn (libisdn stack)])
+	PKG_CHECK_MODULES([libisdn],
+		[libisdn >= 0.0.1],
+		[AC_MSG_CHECKING([libisdn version])
+		 LIBISDN_VERSION="`${PKG_CONFIG} --modversion libisdn`"
+		 if test -z "${LIBISDN_VERSION}"; then
+			AC_MSG_ERROR([Failed to retrieve libisdn version])
+		 fi
+		 AC_MSG_RESULT([${LIBISDN_VERSION}])
+
+		 # check features
+		 AC_MSG_CHECKING([for new experimental API])
+		 AC_COMPILE_IFELSE(
+			[AC_LANG_PROGRAM(
+				[#include <libisdn/version.h>
+				 #if !LIBISDN_FEATURE(API2)
+				 #error "libisdn API v2 not available"
+				 #endif
+				],
+				[;]
+			)],
+			[AC_MSG_RESULT([yes])],
+			[AC_MSG_RESULT([no])]
+		 )
+
+		 HAVE_LIBISDN="yes"
+		 AC_DEFINE([HAVE_LIBISDN], [1], [libisdn support])
+		 AC_SUBST([LIBISDN_CFLAGS],  [${libisdn_CFLAGS}])
+		 AC_SUBST([LIBISDN_CPPFLAGS],[${libisdn_CPPFLAGS}])
+		 AC_SUBST([LIBISDN_LDFLAGS], [${libisdn_LDFLAGS}])
+		 AC_SUBST([LIBISDN_LIBS],    [${libisdn_LIBS}])
+		 AC_SUBST([LIBISDN_VERSION])
+		],
+		[AC_MSG_ERROR([Need libisdn-0.0.1 or higher])]
+	)
+fi
+AM_CONDITIONAL([HAVE_LIBISDN], [test "${HAVE_LIBISDN}" = "yes"])
+
 COMP_VENDOR_CFLAGS="$COMP_VENDOR_CFLAGS"
 AC_SUBST(COMP_VENDOR_CFLAGS)
+
+AC_MSG_RESULT([${as_nl}<<>> Creating output files])
 AC_CONFIG_FILES([Makefile
 		freetdm.pc
 		mod_freetdm/Makefile])
